/*
 * CCVisu is a tool for visual graph clustering
 * and general force-directed graph layout.
 * This file is part of CCVisu.
 *
 * Copyright (C) 2005-2012  Dirk Beyer
 *
 * CCVisu is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * CCVisu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with CCVisu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Please find the GNU Lesser General Public License in file
 * license_lgpl.txt or http://www.gnu.org/licenses/lgpl.txt
 *
 * Dirk Beyer    (firstname.lastname@uni-passau.de)
 * University of Passau, Bavaria, Germany
 */
package org.sosy_lab.ccvisu.writers;

import java.io.PrintWriter;
import java.util.List;

import org.sosy_lab.ccvisu.Options;
import org.sosy_lab.ccvisu.graph.GraphData;
import org.sosy_lab.ccvisu.graph.GraphVertex;
import org.sosy_lab.ccvisu.graph.Relation;

/**
 * Writes the euclidian-distance between all node-pairs of the layout.
 */
public class WriterDataDistHist extends WriterData {

  public WriterDataDistHist(PrintWriter out, GraphData graph) {
    super(out, graph);
  }


  @Override
  public void write() {
    Relation relation = graph.getRelation();
    assert (relation != null);

    out.println("# Generated by " + Options.toolDescription());
    out.println("# " + Options.currentDateTime());
    out.println("# Distances of nodes as CSV (tab):");
    out.println("# NameOfNodeA NameOfNodeB EuclidianDistanceBetweenNodes");

    List<GraphVertex> vertices = graph.getVertices();
    for (int a = vertices.size() - 1; a >= 0; a--) {
      GraphVertex va = vertices.get(a);

      for (int b = a - 1; b >= 0; b--) {
        GraphVertex vb = vertices.get(b);
        out.println(String.format("%s\t%s\t%f", va.getName(), vb.getName(), va.distanceTo(vb)));
      }
    }

    out.flush();
  }
}
